Index: LMDZ6/branches/Amaury_dev/libf/phylmd/dyn1d/mod_1D_cases_read_std.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/dyn1d/mod_1D_cases_read_std.F90	(revision 5143)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/dyn1d/mod_1D_cases_read_std.F90	(revision 5144)
@@ -987,170 +972,168 @@
     do l = 1, llm
 
-       IF (play(l)>=plev_prof_cas(nlev_cas)) THEN
-          mxcalc=l
-          !        print *,'debut interp2, mxcalc=',mxcalc
-          k1=0
-          k2=0
-
-          IF (play(l)<=plev_prof_cas(1)) THEN
-             do k = 1, nlev_cas-1
-                IF (play(l)<=plev_prof_cas(k).AND. play(l)>plev_prof_cas(k+1)) THEN
-                   k1=k
-                   k2=k+1
-                endif
-             enddo
-
-             IF (k1==0 .OR. k2==0) THEN
-                WRITE(*,*) 'PB! k1, k2 = ',k1,k2
-                WRITE(*,*) 'l,play(l) = ',l,play(l)/100
-                do k = 1, nlev_cas-1
-                   WRITE(*,*) 'k,plev_prof_cas(k) = ',k,plev_prof_cas(k)/100
-                enddo
-             endif
-
-
-
-             frac = (plev_prof_cas(k2)-play(l))/(plev_prof_cas(k2)-plev_prof_cas(k1))
-
-             t_mod_cas(l)= t_prof_cas(k2) - frac*(t_prof_cas(k2)-t_prof_cas(k1))
-             theta_mod_cas(l)= th_prof_cas(k2) - frac*(th_prof_cas(k2)-th_prof_cas(k1))
-             IF(theta_mod_cas(l)/=0) t_mod_cas(l)= theta_mod_cas(l)*(play(l)/100000.)**(RD/RCPD)
-             thv_mod_cas(l)= thv_prof_cas(k2) - frac*(thv_prof_cas(k2)-thv_prof_cas(k1))
-             thl_mod_cas(l)= thl_prof_cas(k2) - frac*(thl_prof_cas(k2)-thl_prof_cas(k1))
-             qv_mod_cas(l)= qv_prof_cas(k2) - frac*(qv_prof_cas(k2)-qv_prof_cas(k1))
-             ql_mod_cas(l)= ql_prof_cas(k2) - frac*(ql_prof_cas(k2)-ql_prof_cas(k1))
-             qi_mod_cas(l)= qi_prof_cas(k2) - frac*(qi_prof_cas(k2)-qi_prof_cas(k1))
-             u_mod_cas(l)= u_prof_cas(k2) - frac*(u_prof_cas(k2)-u_prof_cas(k1))
-             v_mod_cas(l)= v_prof_cas(k2) - frac*(v_prof_cas(k2)-v_prof_cas(k1))
-             ug_mod_cas(l)= ug_prof_cas(k2) - frac*(ug_prof_cas(k2)-ug_prof_cas(k1))
-             vg_mod_cas(l)= vg_prof_cas(k2) - frac*(vg_prof_cas(k2)-vg_prof_cas(k1))
-             temp_nudg_mod_cas(l)= temp_nudg_prof_cas(k2) - frac*(temp_nudg_prof_cas(k2)-temp_nudg_prof_cas(k1))
-             qv_nudg_mod_cas(l)= qv_nudg_prof_cas(k2) - frac*(qv_nudg_prof_cas(k2)-qv_nudg_prof_cas(k1))
-             u_nudg_mod_cas(l)= u_nudg_prof_cas(k2) - frac*(u_nudg_prof_cas(k2)-u_nudg_prof_cas(k1))
-             v_nudg_mod_cas(l)= v_nudg_prof_cas(k2) - frac*(v_nudg_prof_cas(k2)-v_nudg_prof_cas(k1))
-
-             invtau_temp_nudg_mod_cas(l)= invtau_temp_nudg_prof_cas(k2) &
-                  - frac*(invtau_temp_nudg_prof_cas(k2)-invtau_temp_nudg_prof_cas(k1))
-             invtau_qv_nudg_mod_cas(l)= invtau_qv_nudg_prof_cas(k2) - frac*(invtau_qv_nudg_prof_cas(k2)-invtau_qv_nudg_prof_cas(k1))
-             invtau_u_nudg_mod_cas(l)= invtau_u_nudg_prof_cas(k2) - frac*(invtau_u_nudg_prof_cas(k2)-invtau_u_nudg_prof_cas(k1))
-             invtau_v_nudg_mod_cas(l)= invtau_v_nudg_prof_cas(k2) - frac*(invtau_v_nudg_prof_cas(k2)-invtau_v_nudg_prof_cas(k1))
-
-             w_mod_cas(l)= vitw_prof_cas(k2) - frac*(vitw_prof_cas(k2)-vitw_prof_cas(k1))
-             omega_mod_cas(l)= omega_prof_cas(k2) - frac*(omega_prof_cas(k2)-omega_prof_cas(k1))
-             du_mod_cas(l)= du_prof_cas(k2) - frac*(du_prof_cas(k2)-du_prof_cas(k1))
-             hu_mod_cas(l)= hu_prof_cas(k2) - frac*(hu_prof_cas(k2)-hu_prof_cas(k1))
-             vu_mod_cas(l)= vu_prof_cas(k2) - frac*(vu_prof_cas(k2)-vu_prof_cas(k1))
-             dv_mod_cas(l)= dv_prof_cas(k2) - frac*(dv_prof_cas(k2)-dv_prof_cas(k1))
-             hv_mod_cas(l)= hv_prof_cas(k2) - frac*(hv_prof_cas(k2)-hv_prof_cas(k1))
-             vv_mod_cas(l)= vv_prof_cas(k2) - frac*(vv_prof_cas(k2)-vv_prof_cas(k1))
-             dt_mod_cas(l)= dt_prof_cas(k2) - frac*(dt_prof_cas(k2)-dt_prof_cas(k1))
-             ht_mod_cas(l)= ht_prof_cas(k2) - frac*(ht_prof_cas(k2)-ht_prof_cas(k1))
-             vt_mod_cas(l)= vt_prof_cas(k2) - frac*(vt_prof_cas(k2)-vt_prof_cas(k1))
-             dth_mod_cas(l)= dth_prof_cas(k2) - frac*(dth_prof_cas(k2)-dth_prof_cas(k1))
-             hth_mod_cas(l)= hth_prof_cas(k2) - frac*(hth_prof_cas(k2)-hth_prof_cas(k1))
-             vth_mod_cas(l)= vth_prof_cas(k2) - frac*(vth_prof_cas(k2)-vth_prof_cas(k1))
-             dq_mod_cas(l)= dq_prof_cas(k2) - frac*(dq_prof_cas(k2)-dq_prof_cas(k1))
-             hq_mod_cas(l)= hq_prof_cas(k2) - frac*(hq_prof_cas(k2)-hq_prof_cas(k1))
-             vq_mod_cas(l)= vq_prof_cas(k2) - frac*(vq_prof_cas(k2)-vq_prof_cas(k1))
-             dtrad_mod_cas(l)= dtrad_prof_cas(k2) - frac*(dtrad_prof_cas(k2)-dtrad_prof_cas(k1))
-
-          else !play>plev_prof_cas(1)
-
-             k1=1
-             k2=2
-             print *,'interp2_vert, k1,k2=',plev_prof_cas(k1),plev_prof_cas(k2)
-             frac1 = (play(l)-plev_prof_cas(k2))/(plev_prof_cas(k1)-plev_prof_cas(k2))
-             frac2 = (play(l)-plev_prof_cas(k1))/(plev_prof_cas(k1)-plev_prof_cas(k2))
-             t_mod_cas(l)= frac1*t_prof_cas(k1) - frac2*t_prof_cas(k2)
-             theta_mod_cas(l)= frac1*th_prof_cas(k1) - frac2*th_prof_cas(k2)
-             IF(theta_mod_cas(l)/=0) t_mod_cas(l)= theta_mod_cas(l)*(play(l)/100000.)**(RD/RCPD)
-             thv_mod_cas(l)= frac1*thv_prof_cas(k1) - frac2*thv_prof_cas(k2)
-             thl_mod_cas(l)= frac1*thl_prof_cas(k1) - frac2*thl_prof_cas(k2)
-             qv_mod_cas(l)= frac1*qv_prof_cas(k1) - frac2*qv_prof_cas(k2)
-             ql_mod_cas(l)= frac1*ql_prof_cas(k1) - frac2*ql_prof_cas(k2)
-             qi_mod_cas(l)= frac1*qi_prof_cas(k1) - frac2*qi_prof_cas(k2)
-             u_mod_cas(l)= frac1*u_prof_cas(k1) - frac2*u_prof_cas(k2)
-             v_mod_cas(l)= frac1*v_prof_cas(k1) - frac2*v_prof_cas(k2)
-             ug_mod_cas(l)= frac1*ug_prof_cas(k1) - frac2*ug_prof_cas(k2)
-             vg_mod_cas(l)= frac1*vg_prof_cas(k1) - frac2*vg_prof_cas(k2)
-             temp_nudg_mod_cas(l)= frac1*temp_nudg_prof_cas(k1) - frac2*temp_nudg_prof_cas(k2)
-             qv_nudg_mod_cas(l)= frac1*qv_nudg_prof_cas(k1) - frac2*qv_nudg_prof_cas(k2)
-             u_nudg_mod_cas(l)= frac1*u_nudg_prof_cas(k1) - frac2*u_nudg_prof_cas(k2)
-             v_nudg_mod_cas(l)= frac1*v_nudg_prof_cas(k1) - frac2*v_nudg_prof_cas(k2)
-
-             invtau_temp_nudg_mod_cas(l)= frac1*invtau_temp_nudg_prof_cas(k1) - frac2*invtau_temp_nudg_prof_cas(k2)
-             invtau_qv_nudg_mod_cas(l)= frac1*invtau_qv_nudg_prof_cas(k1) - frac2*invtau_qv_nudg_prof_cas(k2)
-             invtau_u_nudg_mod_cas(l)= frac1*invtau_u_nudg_prof_cas(k1) - frac2*invtau_u_nudg_prof_cas(k2)
-             invtau_v_nudg_mod_cas(l)= frac1*invtau_v_nudg_prof_cas(k1) - frac2*invtau_v_nudg_prof_cas(k2)
-
-             w_mod_cas(l)= frac1*vitw_prof_cas(k1) - frac2*vitw_prof_cas(k2)
-             omega_mod_cas(l)= frac1*omega_prof_cas(k1) - frac2*omega_prof_cas(k2)
-             du_mod_cas(l)= frac1*du_prof_cas(k1) - frac2*du_prof_cas(k2)
-             hu_mod_cas(l)= frac1*hu_prof_cas(k1) - frac2*hu_prof_cas(k2)
-             vu_mod_cas(l)= frac1*vu_prof_cas(k1) - frac2*vu_prof_cas(k2)
-             dv_mod_cas(l)= frac1*dv_prof_cas(k1) - frac2*dv_prof_cas(k2)
-             hv_mod_cas(l)= frac1*hv_prof_cas(k1) - frac2*hv_prof_cas(k2)
-             vv_mod_cas(l)= frac1*vv_prof_cas(k1) - frac2*vv_prof_cas(k2)
-             dt_mod_cas(l)= frac1*dt_prof_cas(k1) - frac2*dt_prof_cas(k2)
-             ht_mod_cas(l)= frac1*ht_prof_cas(k1) - frac2*ht_prof_cas(k2)
-             vt_mod_cas(l)= frac1*vt_prof_cas(k1) - frac2*vt_prof_cas(k2)
-             dth_mod_cas(l)= frac1*dth_prof_cas(k1) - frac2*dth_prof_cas(k2)
-             hth_mod_cas(l)= frac1*hth_prof_cas(k1) - frac2*hth_prof_cas(k2)
-             vth_mod_cas(l)= frac1*vth_prof_cas(k1) - frac2*vth_prof_cas(k2)
-             dq_mod_cas(l)= frac1*dq_prof_cas(k1) - frac2*dq_prof_cas(k2)
-             hq_mod_cas(l)= frac1*hq_prof_cas(k1) - frac2*hq_prof_cas(k2)
-             vq_mod_cas(l)= frac1*vq_prof_cas(k1) - frac2*vq_prof_cas(k2)
-             dtrad_mod_cas(l)= frac1*dtrad_prof_cas(k1) - frac2*dtrad_prof_cas(k2)
-
-          endif ! play.le.plev_prof_cas(1)
-
-       else ! above max altitude of forcing file
-
-          !jyg
-          fact=20.*(plev_prof_cas(nlev_cas)-play(l))/plev_prof_cas(nlev_cas) !jyg
-          fact = max(fact,0.)                                           !jyg
-          fact = exp(-fact)                                             !jyg
-          t_mod_cas(l)= t_prof_cas(nlev_cas)                            !jyg
-          theta_mod_cas(l)= th_prof_cas(nlev_cas)                       !jyg
-          thv_mod_cas(l)= thv_prof_cas(nlev_cas)                        !jyg
-          thl_mod_cas(l)= thl_prof_cas(nlev_cas)                        !jyg
-          qv_mod_cas(l)= qv_prof_cas(nlev_cas)*fact                     !jyg
-          ql_mod_cas(l)= ql_prof_cas(nlev_cas)*fact                     !jyg
-          qi_mod_cas(l)= qi_prof_cas(nlev_cas)*fact                     !jyg
-          u_mod_cas(l)= u_prof_cas(nlev_cas)*fact                       !jyg
-          v_mod_cas(l)= v_prof_cas(nlev_cas)*fact                       !jyg
-          ug_mod_cas(l)= ug_prof_cas(nlev_cas)                          !jyg
-          vg_mod_cas(l)= vg_prof_cas(nlev_cas)                          !jyg
-          temp_nudg_mod_cas(l)= temp_nudg_prof_cas(nlev_cas)            !jyg
-          qv_nudg_mod_cas(l)= qv_nudg_prof_cas(nlev_cas)                !jyg
-          u_nudg_mod_cas(l)= u_nudg_prof_cas(nlev_cas)                  !jyg
-          v_nudg_mod_cas(l)= v_nudg_prof_cas(nlev_cas)                  !jyg
-
-          invtau_temp_nudg_mod_cas(l)= invtau_temp_nudg_prof_cas(nlev_cas)            !jyg
-          invtau_qv_nudg_mod_cas(l)= invtau_qv_nudg_prof_cas(nlev_cas)                !jyg
-          invtau_u_nudg_mod_cas(l)= invtau_u_nudg_prof_cas(nlev_cas)                  !jyg
-          invtau_v_nudg_mod_cas(l)= invtau_v_nudg_prof_cas(nlev_cas)                  !jyg
-
-          thv_mod_cas(l)= thv_prof_cas(nlev_cas)                        !jyg
-          w_mod_cas(l)= 0.0                                             !jyg
-          omega_mod_cas(l)= 0.0                                         !jyg
-          du_mod_cas(l)= du_prof_cas(nlev_cas)*fact 
-          hu_mod_cas(l)= hu_prof_cas(nlev_cas)*fact                     !jyg
-          vu_mod_cas(l)= vu_prof_cas(nlev_cas)*fact                     !jyg
-          dv_mod_cas(l)= dv_prof_cas(nlev_cas)*fact
-          hv_mod_cas(l)= hv_prof_cas(nlev_cas)*fact                     !jyg
-          vv_mod_cas(l)= vv_prof_cas(nlev_cas)*fact                     !jyg
-          dt_mod_cas(l)= dt_prof_cas(nlev_cas) 
-          ht_mod_cas(l)= ht_prof_cas(nlev_cas)                          !jyg
-          vt_mod_cas(l)= vt_prof_cas(nlev_cas)                          !jyg
-          dth_mod_cas(l)= dth_prof_cas(nlev_cas) 
-          hth_mod_cas(l)= hth_prof_cas(nlev_cas)                        !jyg
-          vth_mod_cas(l)= vth_prof_cas(nlev_cas)                        !jyg
-          dq_mod_cas(l)= dq_prof_cas(nlev_cas)*fact 
-          hq_mod_cas(l)= hq_prof_cas(nlev_cas)*fact                     !jyg
-          vq_mod_cas(l)= vq_prof_cas(nlev_cas)*fact                     !jyg
-          dtrad_mod_cas(l)= dtrad_prof_cas(nlev_cas)*fact               !jyg
-
-       endif ! play
+      IF (play(l)>=plev_prof_cas(nlev_cas)) THEN
+        mxcalc = l
+        !        print *,'debut interp2, mxcalc=',mxcalc
+        k1 = 0
+        k2 = 0
+
+        IF (play(l)<=plev_prof_cas(1)) THEN
+          do k = 1, nlev_cas - 1
+            IF (play(l)<=plev_prof_cas(k).AND. play(l)>plev_prof_cas(k + 1)) THEN
+              k1 = k
+              k2 = k + 1
+            endif
+          enddo
+
+          IF (k1==0 .OR. k2==0) THEN
+            WRITE(*, *) 'PB! k1, k2 = ', k1, k2
+            WRITE(*, *) 'l,play(l) = ', l, play(l) / 100
+            do k = 1, nlev_cas - 1
+              WRITE(*, *) 'k,plev_prof_cas(k) = ', k, plev_prof_cas(k) / 100
+            enddo
+          endif
+
+          frac = (plev_prof_cas(k2) - play(l)) / (plev_prof_cas(k2) - plev_prof_cas(k1))
+
+          t_mod_cas(l) = t_prof_cas(k2) - frac * (t_prof_cas(k2) - t_prof_cas(k1))
+          theta_mod_cas(l) = th_prof_cas(k2) - frac * (th_prof_cas(k2) - th_prof_cas(k1))
+          IF(theta_mod_cas(l)/=0) t_mod_cas(l) = theta_mod_cas(l) * (play(l) / 100000.)**(RD / RCPD)
+          thv_mod_cas(l) = thv_prof_cas(k2) - frac * (thv_prof_cas(k2) - thv_prof_cas(k1))
+          thl_mod_cas(l) = thl_prof_cas(k2) - frac * (thl_prof_cas(k2) - thl_prof_cas(k1))
+          qv_mod_cas(l) = qv_prof_cas(k2) - frac * (qv_prof_cas(k2) - qv_prof_cas(k1))
+          ql_mod_cas(l) = ql_prof_cas(k2) - frac * (ql_prof_cas(k2) - ql_prof_cas(k1))
+          qi_mod_cas(l) = qi_prof_cas(k2) - frac * (qi_prof_cas(k2) - qi_prof_cas(k1))
+          u_mod_cas(l) = u_prof_cas(k2) - frac * (u_prof_cas(k2) - u_prof_cas(k1))
+          v_mod_cas(l) = v_prof_cas(k2) - frac * (v_prof_cas(k2) - v_prof_cas(k1))
+          ug_mod_cas(l) = ug_prof_cas(k2) - frac * (ug_prof_cas(k2) - ug_prof_cas(k1))
+          vg_mod_cas(l) = vg_prof_cas(k2) - frac * (vg_prof_cas(k2) - vg_prof_cas(k1))
+          temp_nudg_mod_cas(l) = temp_nudg_prof_cas(k2) - frac * (temp_nudg_prof_cas(k2) - temp_nudg_prof_cas(k1))
+          qv_nudg_mod_cas(l) = qv_nudg_prof_cas(k2) - frac * (qv_nudg_prof_cas(k2) - qv_nudg_prof_cas(k1))
+          u_nudg_mod_cas(l) = u_nudg_prof_cas(k2) - frac * (u_nudg_prof_cas(k2) - u_nudg_prof_cas(k1))
+          v_nudg_mod_cas(l) = v_nudg_prof_cas(k2) - frac * (v_nudg_prof_cas(k2) - v_nudg_prof_cas(k1))
+
+          invtau_temp_nudg_mod_cas(l) = invtau_temp_nudg_prof_cas(k2) &
+                  - frac * (invtau_temp_nudg_prof_cas(k2) - invtau_temp_nudg_prof_cas(k1))
+          invtau_qv_nudg_mod_cas(l) = invtau_qv_nudg_prof_cas(k2) - frac * (invtau_qv_nudg_prof_cas(k2) - invtau_qv_nudg_prof_cas(k1))
+          invtau_u_nudg_mod_cas(l) = invtau_u_nudg_prof_cas(k2) - frac * (invtau_u_nudg_prof_cas(k2) - invtau_u_nudg_prof_cas(k1))
+          invtau_v_nudg_mod_cas(l) = invtau_v_nudg_prof_cas(k2) - frac * (invtau_v_nudg_prof_cas(k2) - invtau_v_nudg_prof_cas(k1))
+
+          w_mod_cas(l) = vitw_prof_cas(k2) - frac * (vitw_prof_cas(k2) - vitw_prof_cas(k1))
+          omega_mod_cas(l) = omega_prof_cas(k2) - frac * (omega_prof_cas(k2) - omega_prof_cas(k1))
+          du_mod_cas(l) = du_prof_cas(k2) - frac * (du_prof_cas(k2) - du_prof_cas(k1))
+          hu_mod_cas(l) = hu_prof_cas(k2) - frac * (hu_prof_cas(k2) - hu_prof_cas(k1))
+          vu_mod_cas(l) = vu_prof_cas(k2) - frac * (vu_prof_cas(k2) - vu_prof_cas(k1))
+          dv_mod_cas(l) = dv_prof_cas(k2) - frac * (dv_prof_cas(k2) - dv_prof_cas(k1))
+          hv_mod_cas(l) = hv_prof_cas(k2) - frac * (hv_prof_cas(k2) - hv_prof_cas(k1))
+          vv_mod_cas(l) = vv_prof_cas(k2) - frac * (vv_prof_cas(k2) - vv_prof_cas(k1))
+          dt_mod_cas(l) = dt_prof_cas(k2) - frac * (dt_prof_cas(k2) - dt_prof_cas(k1))
+          ht_mod_cas(l) = ht_prof_cas(k2) - frac * (ht_prof_cas(k2) - ht_prof_cas(k1))
+          vt_mod_cas(l) = vt_prof_cas(k2) - frac * (vt_prof_cas(k2) - vt_prof_cas(k1))
+          dth_mod_cas(l) = dth_prof_cas(k2) - frac * (dth_prof_cas(k2) - dth_prof_cas(k1))
+          hth_mod_cas(l) = hth_prof_cas(k2) - frac * (hth_prof_cas(k2) - hth_prof_cas(k1))
+          vth_mod_cas(l) = vth_prof_cas(k2) - frac * (vth_prof_cas(k2) - vth_prof_cas(k1))
+          dq_mod_cas(l) = dq_prof_cas(k2) - frac * (dq_prof_cas(k2) - dq_prof_cas(k1))
+          hq_mod_cas(l) = hq_prof_cas(k2) - frac * (hq_prof_cas(k2) - hq_prof_cas(k1))
+          vq_mod_cas(l) = vq_prof_cas(k2) - frac * (vq_prof_cas(k2) - vq_prof_cas(k1))
+          dtrad_mod_cas(l) = dtrad_prof_cas(k2) - frac * (dtrad_prof_cas(k2) - dtrad_prof_cas(k1))
+
+        else !play>plev_prof_cas(1)
+
+          k1 = 1
+          k2 = 2
+          print *, 'interp2_vert, k1,k2=', plev_prof_cas(k1), plev_prof_cas(k2)
+          frac1 = (play(l) - plev_prof_cas(k2)) / (plev_prof_cas(k1) - plev_prof_cas(k2))
+          frac2 = (play(l) - plev_prof_cas(k1)) / (plev_prof_cas(k1) - plev_prof_cas(k2))
+          t_mod_cas(l) = frac1 * t_prof_cas(k1) - frac2 * t_prof_cas(k2)
+          theta_mod_cas(l) = frac1 * th_prof_cas(k1) - frac2 * th_prof_cas(k2)
+          IF(theta_mod_cas(l)/=0) t_mod_cas(l) = theta_mod_cas(l) * (play(l) / 100000.)**(RD / RCPD)
+          thv_mod_cas(l) = frac1 * thv_prof_cas(k1) - frac2 * thv_prof_cas(k2)
+          thl_mod_cas(l) = frac1 * thl_prof_cas(k1) - frac2 * thl_prof_cas(k2)
+          qv_mod_cas(l) = frac1 * qv_prof_cas(k1) - frac2 * qv_prof_cas(k2)
+          ql_mod_cas(l) = frac1 * ql_prof_cas(k1) - frac2 * ql_prof_cas(k2)
+          qi_mod_cas(l) = frac1 * qi_prof_cas(k1) - frac2 * qi_prof_cas(k2)
+          u_mod_cas(l) = frac1 * u_prof_cas(k1) - frac2 * u_prof_cas(k2)
+          v_mod_cas(l) = frac1 * v_prof_cas(k1) - frac2 * v_prof_cas(k2)
+          ug_mod_cas(l) = frac1 * ug_prof_cas(k1) - frac2 * ug_prof_cas(k2)
+          vg_mod_cas(l) = frac1 * vg_prof_cas(k1) - frac2 * vg_prof_cas(k2)
+          temp_nudg_mod_cas(l) = frac1 * temp_nudg_prof_cas(k1) - frac2 * temp_nudg_prof_cas(k2)
+          qv_nudg_mod_cas(l) = frac1 * qv_nudg_prof_cas(k1) - frac2 * qv_nudg_prof_cas(k2)
+          u_nudg_mod_cas(l) = frac1 * u_nudg_prof_cas(k1) - frac2 * u_nudg_prof_cas(k2)
+          v_nudg_mod_cas(l) = frac1 * v_nudg_prof_cas(k1) - frac2 * v_nudg_prof_cas(k2)
+
+          invtau_temp_nudg_mod_cas(l) = frac1 * invtau_temp_nudg_prof_cas(k1) - frac2 * invtau_temp_nudg_prof_cas(k2)
+          invtau_qv_nudg_mod_cas(l) = frac1 * invtau_qv_nudg_prof_cas(k1) - frac2 * invtau_qv_nudg_prof_cas(k2)
+          invtau_u_nudg_mod_cas(l) = frac1 * invtau_u_nudg_prof_cas(k1) - frac2 * invtau_u_nudg_prof_cas(k2)
+          invtau_v_nudg_mod_cas(l) = frac1 * invtau_v_nudg_prof_cas(k1) - frac2 * invtau_v_nudg_prof_cas(k2)
+
+          w_mod_cas(l) = frac1 * vitw_prof_cas(k1) - frac2 * vitw_prof_cas(k2)
+          omega_mod_cas(l) = frac1 * omega_prof_cas(k1) - frac2 * omega_prof_cas(k2)
+          du_mod_cas(l) = frac1 * du_prof_cas(k1) - frac2 * du_prof_cas(k2)
+          hu_mod_cas(l) = frac1 * hu_prof_cas(k1) - frac2 * hu_prof_cas(k2)
+          vu_mod_cas(l) = frac1 * vu_prof_cas(k1) - frac2 * vu_prof_cas(k2)
+          dv_mod_cas(l) = frac1 * dv_prof_cas(k1) - frac2 * dv_prof_cas(k2)
+          hv_mod_cas(l) = frac1 * hv_prof_cas(k1) - frac2 * hv_prof_cas(k2)
+          vv_mod_cas(l) = frac1 * vv_prof_cas(k1) - frac2 * vv_prof_cas(k2)
+          dt_mod_cas(l) = frac1 * dt_prof_cas(k1) - frac2 * dt_prof_cas(k2)
+          ht_mod_cas(l) = frac1 * ht_prof_cas(k1) - frac2 * ht_prof_cas(k2)
+          vt_mod_cas(l) = frac1 * vt_prof_cas(k1) - frac2 * vt_prof_cas(k2)
+          dth_mod_cas(l) = frac1 * dth_prof_cas(k1) - frac2 * dth_prof_cas(k2)
+          hth_mod_cas(l) = frac1 * hth_prof_cas(k1) - frac2 * hth_prof_cas(k2)
+          vth_mod_cas(l) = frac1 * vth_prof_cas(k1) - frac2 * vth_prof_cas(k2)
+          dq_mod_cas(l) = frac1 * dq_prof_cas(k1) - frac2 * dq_prof_cas(k2)
+          hq_mod_cas(l) = frac1 * hq_prof_cas(k1) - frac2 * hq_prof_cas(k2)
+          vq_mod_cas(l) = frac1 * vq_prof_cas(k1) - frac2 * vq_prof_cas(k2)
+          dtrad_mod_cas(l) = frac1 * dtrad_prof_cas(k1) - frac2 * dtrad_prof_cas(k2)
+
+        endif ! play.le.plev_prof_cas(1)
+
+      else ! above max altitude of forcing file
+
+        !jyg
+        fact = 20. * (plev_prof_cas(nlev_cas) - play(l)) / plev_prof_cas(nlev_cas) !jyg
+        fact = max(fact, 0.)                                           !jyg
+        fact = exp(-fact)                                             !jyg
+        t_mod_cas(l) = t_prof_cas(nlev_cas)                            !jyg
+        theta_mod_cas(l) = th_prof_cas(nlev_cas)                       !jyg
+        thv_mod_cas(l) = thv_prof_cas(nlev_cas)                        !jyg
+        thl_mod_cas(l) = thl_prof_cas(nlev_cas)                        !jyg
+        qv_mod_cas(l) = qv_prof_cas(nlev_cas) * fact                     !jyg
+        ql_mod_cas(l) = ql_prof_cas(nlev_cas) * fact                     !jyg
+        qi_mod_cas(l) = qi_prof_cas(nlev_cas) * fact                     !jyg
+        u_mod_cas(l) = u_prof_cas(nlev_cas) * fact                       !jyg
+        v_mod_cas(l) = v_prof_cas(nlev_cas) * fact                       !jyg
+        ug_mod_cas(l) = ug_prof_cas(nlev_cas)                          !jyg
+        vg_mod_cas(l) = vg_prof_cas(nlev_cas)                          !jyg
+        temp_nudg_mod_cas(l) = temp_nudg_prof_cas(nlev_cas)            !jyg
+        qv_nudg_mod_cas(l) = qv_nudg_prof_cas(nlev_cas)                !jyg
+        u_nudg_mod_cas(l) = u_nudg_prof_cas(nlev_cas)                  !jyg
+        v_nudg_mod_cas(l) = v_nudg_prof_cas(nlev_cas)                  !jyg
+
+        invtau_temp_nudg_mod_cas(l) = invtau_temp_nudg_prof_cas(nlev_cas)            !jyg
+        invtau_qv_nudg_mod_cas(l) = invtau_qv_nudg_prof_cas(nlev_cas)                !jyg
+        invtau_u_nudg_mod_cas(l) = invtau_u_nudg_prof_cas(nlev_cas)                  !jyg
+        invtau_v_nudg_mod_cas(l) = invtau_v_nudg_prof_cas(nlev_cas)                  !jyg
+
+        thv_mod_cas(l) = thv_prof_cas(nlev_cas)                        !jyg
+        w_mod_cas(l) = 0.0                                             !jyg
+        omega_mod_cas(l) = 0.0                                         !jyg
+        du_mod_cas(l) = du_prof_cas(nlev_cas) * fact
+        hu_mod_cas(l) = hu_prof_cas(nlev_cas) * fact                     !jyg
+        vu_mod_cas(l) = vu_prof_cas(nlev_cas) * fact                     !jyg
+        dv_mod_cas(l) = dv_prof_cas(nlev_cas) * fact
+        hv_mod_cas(l) = hv_prof_cas(nlev_cas) * fact                     !jyg
+        vv_mod_cas(l) = vv_prof_cas(nlev_cas) * fact                     !jyg
+        dt_mod_cas(l) = dt_prof_cas(nlev_cas)
+        ht_mod_cas(l) = ht_prof_cas(nlev_cas)                          !jyg
+        vt_mod_cas(l) = vt_prof_cas(nlev_cas)                          !jyg
+        dth_mod_cas(l) = dth_prof_cas(nlev_cas)
+        hth_mod_cas(l) = hth_prof_cas(nlev_cas)                        !jyg
+        vth_mod_cas(l) = vth_prof_cas(nlev_cas)                        !jyg
+        dq_mod_cas(l) = dq_prof_cas(nlev_cas) * fact
+        hq_mod_cas(l) = hq_prof_cas(nlev_cas) * fact                     !jyg
+        vq_mod_cas(l) = vq_prof_cas(nlev_cas) * fact                     !jyg
+        dtrad_mod_cas(l) = dtrad_prof_cas(nlev_cas) * fact               !jyg
+
+      endif ! play
 
     enddo ! l
@@ -1158,55 +1141,48 @@
     ! for variables defined at layer interfaces (EV):
 
-
-    do l = 1, llm+1
-
-       IF (plev(l)>=plev_prof_cas(nlev_cas)) THEN
-          mxcalc=l
-          k1=0
-          k2=0
-
-          IF (plev(l)<=plev_prof_cas(1)) THEN
-             do k = 1, nlev_cas-1
-                IF (plev(l)<=plev_prof_cas(k).AND. plev(l)>plev_prof_cas(k+1)) THEN
-                   k1=k
-                   k2=k+1
-                endif
-             enddo
-
-             IF (k1==0 .OR. k2==0) THEN
-                WRITE(*,*) 'PB! k1, k2 = ',k1,k2
-                WRITE(*,*) 'l,plev(l) = ',l,plev(l)/100
-                do k = 1, nlev_cas-1
-                   WRITE(*,*) 'k,plev_prof_cas(k) = ',k,plev_prof_cas(k)/100
-                enddo
-             endif
-
-             frac = (plev_prof_cas(k2)-plev(l))/(plev_prof_cas(k2)-plev_prof_cas(k1))
-             tke_mod_cas(l)= tke_prof_cas(k2) - frac*(tke_prof_cas(k2)-tke_prof_cas(k1))
-          else !play>plev_prof_cas(1)
-             k1=1
-             k2=2
-             frac1 = (play(l)-plev_prof_cas(k2))/(plev_prof_cas(k1)-plev_prof_cas(k2))
-             frac2 = (play(l)-plev_prof_cas(k1))/(plev_prof_cas(k1)-plev_prof_cas(k2))
-             tke_mod_cas(l)= frac1*tke_prof_cas(k1) - frac2*tke_prof_cas(k2)
-
-          endif ! plev.le.plev_prof_cas(1)
-
-       else ! above max altitude of forcing file
-
-          tke_mod_cas(l)=0.0
-
-       endif ! plev
+    do l = 1, llm + 1
+
+      IF (plev(l)>=plev_prof_cas(nlev_cas)) THEN
+        mxcalc = l
+        k1 = 0
+        k2 = 0
+
+        IF (plev(l)<=plev_prof_cas(1)) THEN
+          do k = 1, nlev_cas - 1
+            IF (plev(l)<=plev_prof_cas(k).AND. plev(l)>plev_prof_cas(k + 1)) THEN
+              k1 = k
+              k2 = k + 1
+            endif
+          enddo
+
+          IF (k1==0 .OR. k2==0) THEN
+            WRITE(*, *) 'PB! k1, k2 = ', k1, k2
+            WRITE(*, *) 'l,plev(l) = ', l, plev(l) / 100
+            do k = 1, nlev_cas - 1
+              WRITE(*, *) 'k,plev_prof_cas(k) = ', k, plev_prof_cas(k) / 100
+            enddo
+          endif
+
+          frac = (plev_prof_cas(k2) - plev(l)) / (plev_prof_cas(k2) - plev_prof_cas(k1))
+          tke_mod_cas(l) = tke_prof_cas(k2) - frac * (tke_prof_cas(k2) - tke_prof_cas(k1))
+        else !play>plev_prof_cas(1)
+          k1 = 1
+          k2 = 2
+          frac1 = (play(l) - plev_prof_cas(k2)) / (plev_prof_cas(k1) - plev_prof_cas(k2))
+          frac2 = (play(l) - plev_prof_cas(k1)) / (plev_prof_cas(k1) - plev_prof_cas(k2))
+          tke_mod_cas(l) = frac1 * tke_prof_cas(k1) - frac2 * tke_prof_cas(k2)
+
+        endif ! plev.le.plev_prof_cas(1)
+
+      else ! above max altitude of forcing file
+
+        tke_mod_cas(l) = 0.0
+
+      endif ! plev
 
     enddo ! l
 
-
-
-
   END SUBROUTINE  interp2_case_vertical_std
-  !***************************************************************************** 
-
-
-
+  !*****************************************************************************
 
 
Index: LMDZ6/branches/Amaury_dev/libf/phylmd/dyn1d/old_1DUTILS_read_interp.h
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/dyn1d/old_1DUTILS_read_interp.h	(revision 5143)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/dyn1d/old_1DUTILS_read_interp.h	(revision 5144)
@@ -2372,7 +2372,8 @@
             nf90_inq_dimid,nf90_inquire_dimension
 
+            USE lmdz_yomcst
+
       IMPLICIT NONE
 
-      INCLUDE "YOMCST.h"
 
       INTEGER ntime,nlevel
@@ -2945,7 +2946,8 @@
 
       SUBROUTINE read_circ(nlev_circ,cf,lwp,iwp,reliq,reice,t,z,p,pm,h2o,o3,sza)
+
+      USE lmdz_yomcst
       
       parameter (ncm_1=49180)
-      INCLUDE "YOMCST.h"
 
       REAL albsfc(ncm_1), albsfc_w(ncm_1)
@@ -3051,5 +3053,5 @@
       SUBROUTINE read_rtmip(nlev_rtmip,play,plev,t,h2o,o3)
       
-      INCLUDE "YOMCST.h"
+      USE lmdz_yomcst
 
       REAL t(nlev_rtmip), pt(nlev_rtmip),pb(nlev_rtmip),h2o(nlev_rtmip), o3(nlev_rtmip)
